﻿using UnityEngine;

namespace EngineTuneControl
{
    class EngineTunePart : PartModule
    {
        private float _currentThrottle;

        public override void OnStart(StartState state)
        {
            if (state == StartState.Editor) return;
            base.OnStart(state);
            vessel.OnFlyByWire += FlyByWare;
        }

        private void FlyByWare(FlightCtrlState st)
        {
            if (!TuneControlSettings.Instance.IsEnabled) return;

            if (GameSettings.THROTTLE_UP.GetKey())
                if (_currentThrottle < 1f)
                    _currentThrottle += TuneControlSettings.Instance.EngineDividerValue;
            if (GameSettings.THROTTLE_DOWN.GetKey())
                if (_currentThrottle > 0)
                    _currentThrottle -= TuneControlSettings.Instance.EngineDividerValue;

            if (_currentThrottle > 1) _currentThrottle = 1f;
            if (_currentThrottle < 0) _currentThrottle = 0;

            st.mainThrottle = _currentThrottle;
            Debug.Log("Current throttle " + _currentThrottle);
        }

        public void OnDestroy()
        {
            // ReSharper disable once DelegateSubtraction
            vessel.OnFlyByWire -= FlyByWare;
        }

    }
}
