﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EngineTuneControl.KSPPluginFramework;
using EngineTuneControl.ToolBar;

namespace EngineTuneControl
{
    class EngineTuneToolbar:MonoBehaviourExtended
    {
        private IButton _button;
        
        internal override void Awake()
        {
            if (ToolbarManager.ToolbarAvailable)
            {
                _button = ToolbarManager.Instance.add("EngineTuneControl", "engineControlButton");
                _button.TexturePath = "EngineTuneControl/Icons/remote_control";
                _button.ToolTip = "LaunchCountDownExtended";
                _button.OnClick += _button_Click;
                _button.Visibility = new GameScenesVisibility(GameScenes.FLIGHT);
                _button.Enabled = true;
            } 
        }

        private void _button_Click(ClickEvent e)
        {
            if (OnClick != null)
            {
                OnClick(this, EventArgs.Empty);
            } 
        }

        internal override void OnDestroy()
        {
            _button.OnClick -= _button_Click;
            _button.Destroy();
            
            base.OnDestroy();
        }

        internal event EventHandler OnClick;
    }
}
